#define _EVENTS_C

#include "config.h"
#include "error.h"
#include "time.h"
#include "ladc.h"
#include "events.h"
#include "event_types.h"

uint32_t handled_events = 0;
unsigned char store_events = 0;
unsigned short mmevents = EVENT_BUFFER_SIZE;
DetectorEventS mmevent[EVENT_BUFFER_SIZE + 1];


int EVENTregister(unsigned char detectors_number, unsigned long event_time, unsigned char *data) {
    int i;
	
    if (mmevents<EVENT_BUFFER_SIZE) {
	for (i=0;i<detectors_number;i++)
	    mmevent[mmevents].detectors[i] = data[i];

	mmevent[mmevents].us = event_time;

	if (buffer1_new_iteration) {
	    mmevent[mmevents].iter = iter-1;
	} else {
	    mmevent[mmevents].iter = iter;
	}
	mmevents++;

	return 1;
    } else {
	if (store_events)
	    ERRORregister(MCU_ERROR_EVENT_BUFFER_FULL);
	    
	return 0;
    }
}

void EVENTenable() {
    if (!store_events) {
	store_events = 1;
	mmevents = 0;
    }
}

void EVENTdisable() {
    store_events = 0;
    mmevents = EVENT_BUFFER_SIZE;
}

void EVENTsetup() {
#ifdef HAVE_LAYOUT
    handled_events = 0xFFFF;
#else /* HAVE_LAYOUT */
    handled_events = 0;
#endif /* HAVE_LAYOUT */
    
#ifdef REGISTER_EVENTS_MANY_MANY
    handled_events |= EVENT_TYPE_MANY_MANY;
#endif /* REGISTER_EVENTS_MANY_MANY */

#ifdef REGISTER_EVENTS_MANY4_MANY4
    handled_events |= EVENT_TYPE_MANY4_MANY4;
#endif /* REGISTER_EVENTS_MANY4_MANY4 */

#ifdef REGISTER_EVENTS_HORIZONTAL_LAYER1
    handled_events |= EVENT_TYPE_HORIZONTAL_LAYER1;
#endif /* REGISTER_EVENTS_HORIZONTAL_LAYER1 */

#ifdef REGISTER_EVENTS_HORIZONTAL_LAYER2
    handled_events |= EVENT_TYPE_HORIZONTAL_LAYER2;
#endif /* REGISTER_EVENTS_HORIZONTAL_LAYER2 */

#ifdef REGISTER_EVENTS_MANY_MANY_THRESHOLDED
    handled_events |= EVENT_TYPE_MANY_MANY_THRESHOLDED;
#endif /* REGISTER_EVENTS_MANY_MANY_THRESHOLDED */

#ifdef REGISTER_EVENTS_FIRST_8
    handled_events |= EVENT_TYPE_FIRST_8;
#endif /* REGISTER_EVENTS_FIRST_8 */

#ifdef REGISTER_EVENTS_FIRST_16
    handled_events |= EVENT_TYPE_FIRST_16;
#endif /* REGISTER_EVENTS_FIRST_16 */

     EVENTdisable();
}
